###########################################
#                                         #
#  Improvements and feedback are welcome  #
#                                         #
#  This file is released under GPL >= 3   #
#                                         #
###########################################

# required stuff
find_package( TQt )
if( WITH_TDE )
  find_package( TDE )
endif( )

tde_setup_architecture_flags( )

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

tde_setup_largefiles( )


##### check for gcc visibility support

if( WITH_GCC_VISIBILITY )
  tde_setup_gcc_visibility( )
endif( WITH_GCC_VISIBILITY )


##### build with TDE integration

if( WITH_TDE )
  set( USE_KDE 1 )
endif( )


##### check for chmlib

if( WITH_CHMLIB )
  check_include_file( "chm_lib.h" CHMLIB_INCLUDE )
  find_library( CHMLIB_LIBRARIES NAMES chm )

  if( NOT CHMLIB_LIBRARIES )
     tde_message_fatal( "extern chmlib has been requested but was not found on your system" )
  endif( NOT CHMLIB_LIBRARIES )
  set( USE_BUILTIN_CHMLIB 0 )
else( )
  set( CHMLIB_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/lib/chmlib )
  set( CHMLIB_LIBRARIES chm-static )
  set( USE_BUILTIN_CHMLIB 1 )
endif( WITH_CHMLIB )
